<?php
/*
This file is part of miniBB. miniBB is free discussion forums/message board software, without any warranty.
See COPYING file for more details. 
Copyright (C) 2014 Paul Puzyrev. www.minibb.com
*/
@set_time_limit(0);
error_reporting (E_ALL);

define ('INCLUDED776',1);
include ('./setup_options.php');
include ($pathToFiles.'setup_'.$DB.'.php');

if(!isset($_GET['action'])){
echo <<<out
<p>Make sure, <b>before running this script you have updated your forums database with the SQL command file</b> named <i>!UPDATE_DB.sql</i><br> from the <a href="http://www.minibb.com/download.php?file=minibb_update" target="_blank">Updates History</a> package, available in our <a href="http://www.minibb.net/download.html">Downloads</a> section.</p>

<p>This utility converts values for the new table fields ONLY if they have been already added. The script doesn't provide automatic new fields creation, since this depends on your mySQL server security settings, and may be impossible for PHP tool. <b>Database upgrading process requires understanding of what you are doing</b>. miniBB developers also provide paid support of upgrading forums in terms of <a href="http://www.minibb.com/paid_support.html" target="_blank">Premium Support</a>.</p>

<p>To start the updating process, please, choose your current forums version below. To determine the version, enter your Admin Panel of miniBB, the version number should be located below the tools table. If it's not there - open bb_functions.php, the number is located at the very top, value of the \$version variable.</p>

<form action="{$main_url}/convdb.php" method=get>
<input type=radio name=action value="1">1.7 series (this will update number of topics, posts, user messages number, topic latest post time) 
<br>
<input type=radio name=action value="2">2.0 RC2b and earlier 2.0 beta series (this will update number of user messages and topic latest post time)
<br>
<input type=radio name=action value="3">2.0.x stable (this will update topic's latest poster username)
<br><br>
<input type=checkbox name=show> Check to not show system output information (on large forums, this will take a lot of download traffic)
<br><br>
<input type=submit value="Continue">
</form>
out;
exit;
}

else {
$action=$_GET['action'];
if(isset($_GET['show']) and $_GET['show']=='on') $show=FALSE; else $show=TRUE;
}

if($action==1){

/* Forums Replies, Topics count */
$uSql="select forum_id from $Tf";

if(($DB=='mysql' and $res=mysql_query($uSql) and mysql_num_rows($res)>0 and $row=mysql_fetch_row($res)) OR ($DB=='mysqli' and $res=mysqli_query($mysqlink, $uSql) and mysqli_num_rows($res)>0 and $row=mysqli_fetch_row($res))){

do{

$forum=$row[0];

$forumReplies=db_calcAmount($Tp,'forum_id',$forum,$Tf,'posts_count');
$forumTopics=db_calcAmount($Tt,'forum_id',$forum,$Tf,'topics_count');

if($show) echo 'Forum '.$forum.' : Replies - '.$forumReplies.' Topics - '.$forumTopics.'<br>';

}

while( ($DB=='mysql' and $row=mysql_fetch_row($res)) OR ($DB=='mysqli' and $row=mysqli_fetch_row($res)) );
}

/* Topics Replies, Topics count */
$uSql="select topic_id,topic_status from $Tt";

if(($DB=='mysql' and $res=mysql_query($uSql) and mysql_num_rows($res)>0 and $row=mysql_fetch_row($res)) OR ($DB=='mysqli' and $res=mysqli_query($mysqlink, $uSql) and mysqli_num_rows($res)>0 and $row=mysqli_fetch_row($res))){

do{

$topic=$row[0];
$sticky=$row[1];
if($sticky==8){

/* Sticky & locked */
$aSql1="update $Tt set topic_status=1 where topic_id=$topic";
$aSql2="update $Tt set sticky=1 where topic_id=$topic";

if($DB=='mysql') mysql_query($uSql);
elseif($DB=='mysqli') mysqli_query($mysqlink, $uSql);

}
elseif($sticky==9){

$aSql1="update $Tt set topic_status=0 where topic_id=$topic";
$aSql2="update $Tt set sticky=1 where topic_id=$topic";

if($DB=='mysql') mysql_query($uSql);
elseif($DB=='mysqli') mysqli_query($mysqlink, $uSql);

}

$topicPosts=db_calcAmount($Tp,'topic_id',$topic,$Tt,'posts_count');

if($show) echo 'Topic '.$topic.' : Replies - '.$topicPosts.'<br>';

}

while( ($DB=='mysql' and $row=mysql_fetch_row($res)) OR ($DB=='mysqli' and $row=mysqli_fetch_row($res)) );
}

} //action 1

if($action==1 or $action==2){
/* User messages amount */

$uSql="select $dbUserId from $Tu";

if(($DB=='mysql' and $res=mysql_query($uSql) and mysql_num_rows($res)>0 and $row=mysql_fetch_row($res)) OR ($DB=='mysqli' and $res=mysqli_query($mysqlink, $uSql) and mysqli_num_rows($res)>0 and $row=mysqli_fetch_row($res))){

do{
$user=$row[0];

$userTopics=db_calcAmount($Tt,'topic_poster',$user,$Tu,$dbUserSheme['num_topics'][1],$dbUserId);
$userReplies=db_calcAmount($Tp,'poster_id',$user,$Tu,$dbUserSheme['num_posts'][1],$dbUserId);

if($show) echo 'User '.$user.' : Replies - '.$userReplies.' Topics - '.$userTopics.'<br>';
}

while( ($DB=='mysql' and $row=mysql_fetch_row($res)) OR ($DB=='mysqli' and $row=mysqli_fetch_row($res)) );
}

} //action=1 or action=2

if($action==1 or $action==2 or $action==3){

/* Topic last post time + username */

$uSql="select topic_id from $Tt order by topic_id desc";

if(($DB=='mysql' and $res=mysql_query($uSql) and mysql_num_rows($res)>0 and $row=mysql_fetch_row($res)) OR ($DB=='mysqli' and $res=mysqli_query($mysqlink, $uSql) and mysqli_num_rows($res)>0 and $row=mysqli_fetch_row($res))){

do{

$topic=$row[0];

$aSql="select post_time, poster_name from $Tp where topic_id=$topic order by post_id DESC limit 1";

if(($DB=='mysql' and $res2=mysql_query($aSql) and mysql_num_rows($res2)>0 and $row2=mysql_fetch_row($res2)) OR ($DB=='mysqli' and $res2=mysqli_query($mysqlink, $aSql) and mysqli_num_rows($res2)>0 and $row2=mysqli_fetch_row($res2))){

$iSql="update $Tt set topic_last_post_time='{$row2[0]}', topic_last_poster='{$row2[1]}' where topic_id='$topic'";

if($DB=='mysql') mysql_query($iSql);
elseif($DB=='mysqli') mysqli_query($mysqlink, $iSql);

}

if($show) echo "Topic {$topic} : Last post time - {$row2[0]} - Last poster - {$row2[1]}<br>";
flush();
}

while( ($DB=='mysql' and $row=mysql_fetch_row($res)) OR ($DB=='mysqli' and $row=mysqli_fetch_row($res)) );
}

} //action=1 or action=2 or $action=3

echo '<p><b>Your database was updated. PLEASE REMOVE NOW convdb.php FROM YOUR FORUMS DIRECTORY - BE AWARE ABOUT YOUR SECURITY AND PROTECTION!</b></p>';

?>